package org.acme.getting.started.countries;

import io.smallrye.mutiny.Uni;
import org.acme.getting.started.countries.model.Country;
import org.eclipse.microprofile.rest.client.inject.RestClient;

import javax.inject.Inject;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;
import java.util.List;

@Path("/country")
public class CountriesResource {

    @Inject
    @RestClient
    CountriesService countriesService;

    @GET
    @Path("/async")
    @Produces(MediaType.APPLICATION_JSON)
    public Uni<List<Country>> async() {
        return countriesService.getByNameAsync("greeces");
    }

    @GET
    @Path("/sync")
    @Produces(MediaType.APPLICATION_JSON)
    public List<Country> sync() {
        return countriesService.getByNameSync("greeces");
    }


}